package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ChangeAdministrativePasswordLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewChangeAdministrativePasswordLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ChangeAdministrativePasswordLogic {
	return &ChangeAdministrativePasswordLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ChangeAdministrativePasswordLogic) ChangeAdministrativePassword(req *types.ChangeAdministrativePasswordReq) (resp *types.ChangeAdministrativePasswordResp, err error) {
	// todo: add your logic here and delete this line
	ChangeAdministrativePasswordReq := &openstack.ChangeAdministrativePasswordReq{}
	err = copier.CopyWithOption(ChangeAdministrativePasswordReq, req, copier.Option{Converters: utils.Converters})
	ChangeAdministrativePasswordResp, err := l.svcCtx.OpenstackRpc.ChangeAdministrativePassword(l.ctx, ChangeAdministrativePasswordReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ChangeAdministrativePasswordResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ChangeAdministrativePasswordResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
